<?php
defined('_NOAH') or die('Restricted access');

class GenerWidget
{

function generHiddenField($name="",$value="", $postfix="")
{
    if( $name )
    {
        $value=htmlspecialchars($value);
        //todo: ide is " kellene a value-hoz, mint a text-ben
        $id = $postfix ? "{$name}_$postfix" : $name;
        return "<input type='hidden' id='$id' name='$name' value='$value'>\n";
    }
}

function generTextField($type,$name,$value="",$size="", $maxlength="", $extra="")
// a password es a button mezot is ezzel csinaljuk
{
    $value=htmlspecialchars($value);
    $s="<input type='$type' id='$name' name='$name'";
    if ($value!="") $s.=" value=\"$value\"";
    if ($size!="") $s.=" size='$size'";
    if ($maxlength!="") $s.=" maxlength='$maxlength'";
    if( $type=="submit" ) $s.="class='button'";
    if ($extra!="") $s.=" $extra";
    $s.=">\n";
    return $s;
}

function generTextAreaField($name,$value="",$rows="",$cols="",$readonly=FALSE, $markitup=FALSE)
{
    global $jQueryLib;
    
    if( $markitup )
    {
        JavaScript::addInclude(GORUM_JS_DIR . $jQueryLib);
        JavaScript::addInclude(GORUM_JS_DIR . "/jquery/markitup/jquery.markitup.js");
        JavaScript::addInclude(GORUM_JS_DIR . "/jquery/markitup/sets/$markitup[set]/set.js");
        JavaScript::addCss(GORUM_JS_DIR . "/jquery/markitup/skins/markitup/style.css");
        JavaScript::addCss(GORUM_JS_DIR . "/jquery/markitup/sets/$markitup[set]/style.css");
        $script = "";
        foreach( $markitup as $attr=>$val ) $script.="$markitup[set]MarkitupSettings['$attr']='$val'\n";
        JavaScript::addOnload($script . "$('#$name').markItUp($markitup[set]MarkitupSettings);");
    }
    $value=z_specchars($value);
    $s="<textarea id='$name' name='$name'";
    if ($rows!="") 
    {
        if( is_numeric($rows) ) $s.=" rows='$rows'";
        else $s.=" style='height: $rows'";  // ha '%' vagy 'px' van benne
    }
    if ($cols!="") 
    {
        if( is_numeric($cols) ) $s.=" cols='$cols'";
        else $s.=" style='width: $cols'";  // ha '%' vagy 'px' van benne
    }
    if( $readonly ) $s.=" readonly";
    $s.=">\n";
    if ($value!="") $s.=$value;
    $s.="</textarea>";
    return $s;
}

function generSelectField($name,&$labels,&$values,$id="",$selected=0,$size=0,$width=0,
                          $showRelation="", $extra="")
{
    $s="\n<select name='$name'";
    if ($id) $s.=" id='$id'";
    if ($size>0) $s.=" size='$size'";
    if ($width>0) $s.=" width='$width' style='width:{$width}px;'";
    if ($extra!="") $s.=" $extra";
    $s.=">\n";
    if( !in_array($selected, $values) && isset($values[0])) {
        $selected=$values[0];
    }
    foreach($labels as $key=>$label ){
        $s.="<option value='".$values[$key]."'";
        if( $showRelation )
        {
            //if( isset($showRelation[$key]) ) $s.=" show='$showRelation[$key]_rel'";
            if( is_array($showRelation ) && isset($showRelation[$values[$key]]) ) $s.=" show='".$showRelation[$values[$key]]."_rel'";
            elseif( !is_array($showRelation ) && $values[$key]!=0 ) $s.=" show='".$showRelation."_rel'";
            else $s.=" show='none'";
        }
        if ($selected==$values[$key])
        {
            $s.=" selected";
        }
        $s.=">".htmlspecialchars($label)."</option>\n";
    }
    $s.="</select>\n";
    return $s;
}

function generRadioField($name,&$labels,&$values,$selected=0,$cols=1,$showRelation="")
{
    $s="\n<table border='0' colspan='0' rowspan='0'>\n";
    $length = count($values);
    global $noRadioPreset;
    if (!isset($noRadioPreset) && $selected!=-1) {
        if( !in_array($selected, $values) ) $selected=$values[0];
    }
    for( $i=0; $i<$length/$cols; $i++ )
    {
        $s.="<tr>";
        for( $j=$i*$cols; $j<($i+1)*$cols; $j++ )
        {
            if( !isset($values[$j]) ) break(2);
            $v = $values[$j];
            $s.="<td class='celltext'>";
            $s.="<input type='radio' name='$name' value='$v' id='$name"."_$v'";
            if( $showRelation )
            {
                if( isset($showRelation[$v]) ) $s.=" show='$showRelation[$v]_rel'";
                else $s.=" show='none'";
            }
            if( $selected==$v ) 
            {
                $s.=" checked";
            }    
            $s.=">".$labels[$j];
            $s.="</td>\n";
        }
        $s.="</tr>\n";
    }
    $s.="</table>\n";
    return $s;
}

function generBoolField($name, $id="", $checked=FALSE, $value=1, $showRelation="", $extra="")
{
    $s="<input type='checkbox' value='$value'";
    if( $id ) $s.=" id='$id'";
    if( $name ) $s.=" name='$name'";
    if( $showRelation ) $s.=" show='$showRelation"."_rel'";
    if( $checked ) $s.=" checked";
    $s.=">";
    return $s;
}

function generUrlField($name,$value="",$size="",$maxlength="")
{
    global $lll;
    if( $value && is_array($value) )
    {
        $value0 = $value[0];
        $value1 = $value[1];
    }
    elseif( $value )
    {
        $values=split("' target='_blank'>", $value);
        $value0 = htmlspecialchars(substr($values[0], 9));
        $value1 = htmlspecialchars(substr($values[1], 0, -4));
    }
    else $value0 = $value1 = "";
    $s="$lll[linkText]: <input type='text' name='$name"."[1]'";
    if ($value1!="") $s.=" value=\"$value1\"";
    if ($size!="") $s.=" size='$size'";
    if ($maxlength!="") $s.=" maxlength='$maxlength'";
    $s.=">";
    $s.="&nbsp;&nbsp;&nbsp;&nbsp;$lll[URL]: <input type='text' name='$name"."[0]'";
    if ($value0!="") $s.=" value=\"$value0\"";
    if ($size!="") $s.=" size='$size'";
    if ($maxlength!="") $s.=" maxlength='$maxlength'";
    $s.=">\n";
    return $s;
}

function generButtonField($name="",$value="",$class="", $relation="")
{
    $s="<input type='button'";
    if ($value!="") $s.=" value='$value'";
    if ($name!="") $s.=" name='$name'";
    $s.=">\n";
    return $s;
}

function generFileField($name,$size="",$maxlength="", $max_file_size=0)
{
    $s="";
    if( $max_file_size )
    {
        $s.= "<input type='hidden' name='MAX_FILE_SIZE' value='$max_file_size'>\n";
    }
    $s.="<input type='file' name='$name'";
    if ($size!="") $s.=" size='$size'";
    if ($maxlength!="") $s.=" maxlength='$maxlength'";
    $s.=">\n";
    return $s;
}

function generMultipleSelection($name,&$listNames,&$listValues, $selected, $listSize, $width=0,
                                $showRelation="",$anyfield="", $asmSelect=0, $asmSelectLabel="")
{
    global $lll, $jQueryLib;  
    if( $selected=="" ) $selected=array();
    elseif( !is_array($selected) ) $selected=split(", *", $selected);
    if( $asmSelect )
    {
        JavaScript::addInclude(GORUM_JS_DIR . $jQueryLib);
        if( preg_match("/sortable:\s*true/", $asmSelect) )
        {
            JavaScript::addInclude(GORUM_JS_DIR . "/jquery/jquery.dimensions.js");
            JavaScript::addInclude(GORUM_JS_DIR . "/jquery/jquery.ui.js");
        }
        JavaScript::addInclude(GORUM_JS_DIR . "/jquery/jquery.asmselect.js");
        JavaScript::addCss(GORUM_JS_DIR . "/jquery/jquery.asmselect.css");
        JavaScript::addOnload("$('#$name').asmSelect($asmSelect);");
        // hogy egy modify formban a kivalasztottak listajanak sorrendje ugyanaz legyen, 
        // mint amit mar egyszer elmentettunk:
        if( count($selected)>1 )
        {
            $tempSelected = $selected;
            for( $i=0, $helpArr=array(); $i<count($listValues); $i++ ) $helpArr[$listValues[$i]] = $listNames[$i];
            for( $i=0; $i<count($listValues); $i++ )
            {
                if( in_array($listValues[$i], $selected) ) 
                {
                    $listValues[$i] = array_shift($tempSelected);
                    $listNames[$i] = $helpArr[$listValues[$i]];
                }
            }
        }
    }
    $s="\n<select id='$name' name='$name"."[]' size='$listSize' ";
    if ($width>0) $s.="width='$width' style='width:{$width}px;' ";
    if( $asmSelectLabel ) $s.="title='".addcslashes($lll[$asmSelectLabel], "'")."' ";
    $s.="multiple>\n";
    $length = count($listValues);
    if( $length )
    {
        foreach( $listValues as $key=>$value )
        {
            $s.="<option value=\"".$value."\"";
            if( $showRelation )
            {
                if( isset($showRelation[$value]) ) $s.=" show='$showRelation[$value]_rel'";
                else $s.=" show='none'";
            }
            if( in_array($value, $selected) ) $s.=" selected";
            if( $anyfield==$value ) 
            {
                $s.=" src='any'";
            }    
            $s.=">".htmlspecialchars($listNames[$key])."</option>\n";
        }
    }
    else $s.="<option value='0'>".$lll["emptyList"]."</option>\n";    
    $s.="</select>\n";
    return $s;
}

function generCheckbox($name,&$listNames,&$listValues, $selected, $cols, 
                       $vert=FALSE,$showRelation="",$multimask=0, $afterField="",$anyfield="")
{
    global $hackTdClass;
    
    $s="\n<table border='0' colspan='0' rowspan='0'>\n";
    $length = count($listValues);
    if( $selected=="" ) $selected=array();
    elseif ($multimask) {
        $tmp=array();
        for($i=1;$i<2147483648;) {//2147483648 : 2^31
            if (($selected & $i) == $i) {
                $tmp[]=$i;
            }
            if ($i==0) $i++;
            else $i*=2;
        }
        $selected=$tmp;
    }
    elseif( !is_array($selected) ) $selected=split(", *", $selected);
    
    if (isset($hackTdClass) && $hackTdClass) {
        $hTdClass=" class='$hackTdClass'";
    }
    else $hTdClass=" class='celltext'";
    if ($vert) {//vertical
        $rows=ceil($length/$cols);
        $ind1=0;
        $ind2=0;
        $aind=0;
        $aindH=0;
        for( $i=0; $i<$rows; $i++ ) {
            $s.="<tr>";
            for($j=0;$j<$cols;$j++) {
                if( !isset($listValues[$ind2]) ) break;
                $v = $listValues[$ind2];
                $s.="<td$hTdClass>";
                $s.="<input type='checkbox' id='$name"."_$ind2' name='$name"."[$ind2]' value='$v'";
                if( $showRelation )
                {
                    if( isset($showRelation[$v]) ) $s.=" show='$showRelation[$v]_rel'";
                    else $s.=" show='none'";
                }
                if( in_array($v, $selected) ) $s.=" checked";
                if( $anyfield==$v ) 
                {
                    $s.=" src='any'";
                }    
                $s.=">".$listNames[$ind2];
                
                $s.="</td>\n";
                $ind2+=$rows;
            }
            $s.="</tr>\n";
            $ind1++;
            $ind2=$ind1;
        }
    }
    else {//horizontal
        for( $i=0; $i<$length/$cols; $i++ )
        {
            $s.="<tr>";
            for( $j=$i*$cols; $j<($i+1)*$cols; $j++ )
            {
                if( !isset($listValues[$j]) ) break(2);
                $v = $listValues[$j];
                $s.="<td$hTdClass>";
                $s.="<input type='checkbox' id='$name"."_$j' name='$name"."[$j]' value='$v'";
                if( $showRelation )
                {
                    if( isset($showRelation[$v]) ) $s.=" show='$showRelation[$v]_rel'";
                    else $s.=" show='none'";
                }
                if( in_array($v, $selected) ) $s.=" checked";
                if( $anyfield==$v ) 
                {
                    $s.=" src='any'";
                }    
                $s.=">".$listNames[$j];
                $s.="</td>\n";            
            }
            $s.="</tr>\n";
        }
    }
    if ($afterField) {
        $s.="<tr>";
        $s.="<td colspan='$cols'>$afterField</td>";
        $s.="</tr>";
    }
    $s.="</table>\n";
    return $s;
}

function generSelectFilterField($name, &$labels, $width)
{
    if( !$width )
    {
        $width = 0;
        foreach( $labels as $label ) $width = max($width, strlen($label));
    }
    $s="Filter:<br>";
    $s.= GenerWidget::generTextField("text","{$name}_selectfilter","",$width);
    $s.="<br>";
    JavaScript::addOnload("
    function filterSelectField(e)
    {
        e=e||window.event;
        var k=e.charCode||e.keyCode||e.which;						                        
        if(e.ctrlKey || e.altKey) return true;  // ignore
        else if ((k>=41 && k<=122) ||k==32 || k>186 || k==8)  //typeable characters
        {
            var name = this.name.slice(0, -13);  // levagjuk '_selectfilter'-t
            var filter=this.value.toLowerCase();
            // betesszuk egy tombbe az osszes option-t
            if( eval('typeof('+name+'OptionsRepository)!=\"object\"') )
            {
                eval(name+'OptionsRepository = new Array;');
                $('#' + name).find('option').each(function(){
                    eval(name+'OptionsRepository').push([$(this).val(), $(this).html()]);
                });
            }
            $('#' + name).find('option').remove();  // kiuritjuk a szelekt mezot teljesen
            var x=0;
            $.each(eval(name+'OptionsRepository'), function(i, val)
            {
                // es csak azokat tesszuk vissza, amiben a filter megtalalhato:
                if( val[1].toLowerCase().indexOf(filter)>-1 )
                {
                    $('#' + name).get(0).options[x++]=new Option(val[1], val[0]);
                }
            });
        }
    }
    $('input[id$=_selectfilter]').keyup(filterSelectField);
    ", "filterSelectField");
    return $s;
}

function generAnchor( $link, $label, $cssClass="", $target="", $encode=TRUE, $rel="" )
{
    $s="<a href='$link'";
    if( $cssClass ) $s.=" class='$cssClass'";
    if( $target ) $s.=" target='$target'";
    if( $encode ) $label = htmlspecialchars($label);
    if( $rel ) $s.=" rel='$rel'";
    $s.=">$label</a>";
    return $s;
}

function generImageAnchor( $link, $src, $alt, $width="", $height="", $cssClass="", $target="", $rel="" )
{
    $alt = htmlspecialchars($alt);
    $img = "<img src='$src' alt='$alt' border='0' title='$alt'";
    if ($width!="") $img.=" width='$width'";
    if ($height!="") $img.=" height='$height'";
    $img.=">";
    return GenerWidget::generAnchor($link, $img, $cssClass, $target, FALSE, $rel);
}

function initCaptchaField()
{
    global $lll;
    $lll["captchaField_embedfield"]="
        <table><tr><td width='1' style='padding-right: 20px;'>
            <img src='".Controller::getBaseURL()."gorum/captcha/captcha.php' alt='CAPTCHA'></td><td>%s</td></tr>
        </table>";
}

} // end class
?>
